#include <gtest/gtest.h>
#include <test/unit/gm/utility.hpp>

TEST(gm_parser, abs_math_function_signatures) {
  test_parsable("function-signatures/math/functions/abs");
}

TEST(gm_parser, asin_math_function_signatures) {
  test_parsable("function-signatures/math/functions/asin");
}

TEST(gm_parser, asinh_math_function_signatures) {
  test_parsable("function-signatures/math/functions/asinh");
}

TEST(gm_parser, acos_math_function_signatures) {
  test_parsable("function-signatures/math/functions/acos");
}

TEST(gm_parser, acosh_math_function_signatures) {
  test_parsable("function-signatures/math/functions/acosh");
}
 
TEST(gm_parser, atan_math_function_signatures) {
  test_parsable("function-signatures/math/functions/atan");
}

TEST(gm_parser, atan2_math_function_signatures) {
  test_parsable("function-signatures/math/functions/atan2");
}
  
TEST(gm_parser, atanh_math_function_signatures) {
  test_parsable("function-signatures/math/functions/atanh");
}  

TEST(gm_parser, bessel_first_kind_math_function_signatures) {
  test_parsable("function-signatures/math/functions/bessel_first_kind");
}

TEST(gm_parser, bessel_second_kind_math_function_signatures) {
  test_parsable("function-signatures/math/functions/bessel_second_kind");
}

TEST(gm_parser, binary_log_loss_math_function_signatures) {
  test_parsable("function-signatures/math/functions/binary_log_loss");
}

TEST(gm_parser, binomial_coefficient_log_math_function_signatures) {
  test_parsable("function-signatures/math/functions/binomial_coefficient_log");
}

TEST(gm_parser, cbrt_math_function_signatures) {
  test_parsable("function-signatures/math/functions/cbrt");
}

TEST(gm_parser, ceil_math_function_signatures) {
  test_parsable("function-signatures/math/functions/ceil");
}

TEST(gm_parser, constants_math_function_signatures) {
  test_parsable("function-signatures/math/functions/constants");
}

TEST(gm_parser, cos_math_function_signatures) {
  test_parsable("function-signatures/math/functions/cos");
}

TEST(gm_parser, cosh_math_function_signatures) {
  test_parsable("function-signatures/math/functions/cosh");
}

TEST(gm_parser, digamma_math_function_signatures) {
  test_parsable("function-signatures/math/functions/digamma");
}

TEST(gm_parser, erf_math_function_signatures) {
  test_parsable("function-signatures/math/functions/erf"); 
}

TEST(gm_parser, erfc_math_function_signatures) {
  test_parsable("function-signatures/math/functions/erfc"); 
}

TEST(gm_parser, exp_math_function_signatures) {
  test_parsable("function-signatures/math/functions/exp"); 
}

TEST(gm_parser, exp2_math_function_signatures) {
  test_parsable("function-signatures/math/functions/exp2"); 
}

TEST(gm_parser, expm1_math_function_signatures) {
  test_parsable("function-signatures/math/functions/expm1"); 
}

TEST(gm_parser, fabs_math_function_signatures) {
  test_parsable("function-signatures/math/functions/fabs");
}

TEST(gm_parser, falling_factorial_math_function_signatures) {
  test_parsable("function-signatures/math/functions/falling_factorial");
}

TEST(gm_parser, fdim_math_function_signatures) {
  test_parsable("function-signatures/math/functions/fdim");
}
 
TEST(gm_parser, floor_math_function_signatures) {
  test_parsable("function-signatures/math/functions/floor");
}

TEST(gm_parser, fma_math_function_signatures) {
  test_parsable("function-signatures/math/functions/fma");
}

TEST(gm_parser, fmax_math_function_signatures) {
  test_parsable("function-signatures/math/functions/fmax");
}

TEST(gm_parser, fmin_math_function_signatures) {
  test_parsable("function-signatures/math/functions/fmin");
}

TEST(gm_parser, fmod_math_function_signatures) {
  test_parsable("function-signatures/math/functions/fmod");
}

TEST(gm_parser, gamma_p_math_function_signatures) {
  test_parsable("function-signatures/math/functions/gamma_p");
}

TEST(gm_parser, gamma_q_math_function_signatures) {
  test_parsable("function-signatures/math/functions/gamma_q");
}

TEST(gm_parser, hypot_math_function_signatures) {
  test_parsable("function-signatures/math/functions/hypot");
}

TEST(gm_parser, if_else_math_function_signatures) {
  test_parsable("function-signatures/math/functions/if_else");
}

TEST(gm_parser, int_step_math_function_signatures) {
  test_parsable("function-signatures/math/functions/int_step");
}

TEST(gm_parser, inv_math_function_signatures) {
  test_parsable("function-signatures/math/functions/inv");
}

TEST(gm_parser, inv_logit_math_function_signatures) {
  test_parsable("function-signatures/math/functions/inv_logit");
}

TEST(gm_parser, inv_cloglog_math_function_signatures) {
  test_parsable("function-signatures/math/functions/inv_cloglog");
}

TEST(gm_parser, inv_square_math_function_signatures) {
  test_parsable("function-signatures/math/functions/inv_square");
}

TEST(gm_parser, inv_sqrt_math_function_signatures) {
  test_parsable("function-signatures/math/functions/inv_sqrt");
}

TEST(gm_parser, lbeta_math_function_signatures) {
  test_parsable("function-signatures/math/functions/lbeta");
}

TEST(gm_parser, lgamma_math_function_signatures) {
  test_parsable("function-signatures/math/functions/lgamma");
}

TEST(gm_parser, lmgamma_math_function_signatures) {
  test_parsable("function-signatures/math/functions/lmgamma");
}

TEST(gm_parser, log1m_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log1m");
}

TEST(gm_parser, log1m_exp_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log1m_exp");
}

TEST(gm_parser, log1m_inv_logit_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log1m_inv_logit");
}

TEST(gm_parser, log1p_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log1p");
}

TEST(gm_parser, log1p_exp_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log1p_exp");
}

TEST(gm_parser, log_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log");
}

TEST(gm_parser, log10_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log10");
}

TEST(gm_parser, log2_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log2");
}

TEST(gm_parser, log_diff_exp_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log_diff_exp");
}

TEST(gm_parser, log_inv_logit_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log_inv_logit");
}

TEST(gm_parser, logit_math_function_signatures) {
  test_parsable("function-signatures/math/functions/logit"); 
}

TEST(gm_parser, log_falling_factorial_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log_falling_factorial");
}

TEST(gm_parser, log_rising_factorial_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log_rising_factorial");
}

TEST(gm_parser, log_sum_exp_math_function_signatures) {
  test_parsable("function-signatures/math/functions/log_sum_exp");
}

TEST(gm_parser, max_math_function_signatures) {
  test_parsable("function-signatures/math/functions/max");
}

TEST(gm_parser, min_math_function_signatures) {
  test_parsable("function-signatures/math/functions/min");
}

TEST(gm_parser, modified_bessel_first_kind_math_function_signatures) {
  test_parsable("function-signatures/math/functions/modified_bessel_first_kind");
}

TEST(gm_parser, modified_bessel_second_kind_math_function_signatures) {
  test_parsable("function-signatures/math/functions/modified_bessel_second_kind");
}

TEST(gm_parser, multiply_log_math_function_signatures) {
  test_parsable("function-signatures/math/functions/multiply_log");
}

TEST(gm_parser, operators_int_math_function_signatures) {
  test_parsable("function-signatures/math/functions/operators_int");
}

TEST(gm_parser, operators_real_math_function_signatures) {
  test_parsable("function-signatures/math/functions/operators_real");
}

TEST(gm_parser, owens_t_math_function_signatures) {
  test_parsable("function-signatures/math/functions/owens_t");
}

TEST(gm_parser, phi_math_function_signatures) {
  test_parsable("function-signatures/math/functions/phi");
}

TEST(gm_parser, phi_approx_math_function_signatures) {
  test_parsable("function-signatures/math/functions/phi_approx");
}

TEST(gm_parser, pow_math_function_signatures) {
  test_parsable("function-signatures/math/functions/pow");
}

TEST(gm_parser, sin_math_function_signatures) {
  test_parsable("function-signatures/math/functions/sin");
}

TEST(gm_parser, sinh_math_function_signatures) {
  test_parsable("function-signatures/math/functions/sinh");
}

TEST(gm_parser, step_math_function_signatures) {
  test_parsable("function-signatures/math/functions/step");
}

TEST(gm_parser, special_values_math_function_signatures) {
  test_parsable("function-signatures/math/functions/special_values");
}

TEST(gm_parser, sqrt_math_function_signatures) {
  test_parsable("function-signatures/math/functions/sqrt");
}

TEST(gm_parser, square_math_function_signatures) {
  test_parsable("function-signatures/math/functions/square");
}

TEST(gm_parser, rising_factorial_math_function_signatures) {
  test_parsable("function-signatures/math/functions/rising_factorial");
}

TEST(gm_parser, round_math_function_signatures) {
  test_parsable("function-signatures/math/functions/round");
}

TEST(gm_parser, tan_math_function_signatures) {
  test_parsable("function-signatures/math/functions/tan");
}

TEST(gm_parser, tanh_math_function_signatures) {
  test_parsable("function-signatures/math/functions/tanh");
}

TEST(gm_parser, tgamma_math_function_signatures) {
  test_parsable("function-signatures/math/functions/tgamma");
}

TEST(gm_parser, trigamma_math_function_signatures) {
  test_parsable("function-signatures/math/functions/trigamma");
}

TEST(gm_parser, trunc_math_function_signatures) {
  test_parsable("function-signatures/math/functions/trunc");
}
